diff --git a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
new file mode 100644
index 000000000..a374995cc
--- /dev/null
+++ b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
@@ -0,0 +1,1210 @@
+package net.minecraft.client.net.handler;
+
+import com.b100.utils.StringUtils;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.entity.particle.TakeAnimationParticle;
+import net.minecraft.client.entity.player.LocalPlayer;
+import net.minecraft.client.entity.player.RemotePlayer;
+import net.minecraft.client.gui.GuiConnectFailed;
+import net.minecraft.client.gui.GuiDownloadTerrain;
+import net.minecraft.client.gui.GuiIngameMenu;
+import net.minecraft.client.gui.guidebook.GuiGuidebook;
+import net.minecraft.client.gui.guidebook.PageManager;
+import net.minecraft.client.gui.guidebook.search.SearchPage;
+import net.minecraft.client.player.controller.PlayerControllerMP;
+import net.minecraft.client.world.WorldClient;
+import net.minecraft.core.Global;
+import net.minecraft.core.achievement.stat.StatList;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.BlastFurnaceBlockEntity;
+import net.minecraft.core.block.entity.DispenserBlockEntity;
+import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
+import net.minecraft.core.block.entity.FurnaceBlockEntity;
+import net.minecraft.core.block.entity.TrommelBlockEntity;
+import net.minecraft.core.data.DataLoader;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.RecipeRegistry;
+import net.minecraft.core.data.registry.recipe.SearchQuery;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.EntityDispatcher;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.LightningEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.PaintingEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.projectile.Projectile;
+import net.minecraft.core.enums.ArtType;
+import net.minecraft.core.item.MapItem;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.net.NetworkManager;
+import net.minecraft.core.net.PlayerProfile;
+import net.minecraft.core.net.entity.NetEntityHandler;
+import net.minecraft.core.net.handler.PacketHandler;
+import net.minecraft.core.net.packet.AESSendKeyPacket;
+import net.minecraft.core.net.packet.AddEntityPacket;
+import net.minecraft.core.net.packet.AddItemEntityPacket;
+import net.minecraft.core.net.packet.AddMobPacket;
+import net.minecraft.core.net.packet.AddPaintingPacket;
+import net.minecraft.core.net.packet.AddParticlePacket;
+import net.minecraft.core.net.packet.AddPlayerPacket;
+import net.minecraft.core.net.packet.AnimatePacket;
+import net.minecraft.core.net.packet.BedMessagePacket;
+import net.minecraft.core.net.packet.BlockEventPacket;
+import net.minecraft.core.net.packet.BlockRegionUpdatePacket;
+import net.minecraft.core.net.packet.BlockUpdatePacket;
+import net.minecraft.core.net.packet.ChatPacket;
+import net.minecraft.core.net.packet.ChunkBlocksUpdatePacket;
+import net.minecraft.core.net.packet.ChunkVisibilityPacket;
+import net.minecraft.core.net.packet.ContainerAckPacket;
+import net.minecraft.core.net.packet.ContainerClosePacket;
+import net.minecraft.core.net.packet.ContainerOpenPacket;
+import net.minecraft.core.net.packet.ContainerSetContentPacket;
+import net.minecraft.core.net.packet.ContainerSetDataPacket;
+import net.minecraft.core.net.packet.ContainerSetSlotPacket;
+import net.minecraft.core.net.packet.CustomPayloadPacket;
+import net.minecraft.core.net.packet.DisconnectPacket;
+import net.minecraft.core.net.packet.EnitityEventPacket;
+import net.minecraft.core.net.packet.EntityNicknamePacket;
+import net.minecraft.core.net.packet.SetEntityDataPacket;
+import net.minecraft.core.net.packet.EntityTagDataPacket;
+import net.minecraft.core.net.packet.ExplosionPacket;
+import net.minecraft.core.net.packet.FlagOpenPacket;
+import net.minecraft.core.net.packet.GameRulePacket;
+import net.minecraft.core.net.packet.LoginPacket;
+import net.minecraft.core.net.packet.MapDataPacket;
+import net.minecraft.core.net.packet.MoveEntityPacket;
+import net.minecraft.core.net.packet.MovePlayerPacket;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.net.packet.PhotoModePacket;
+import net.minecraft.core.net.packet.PlaySoundEffectDirectPacket;
+import net.minecraft.core.net.packet.PlaySoundEffectPacket;
+import net.minecraft.core.net.packet.PlayerGamemodePacket;
+import net.minecraft.core.net.packet.PlayerListPacket;
+import net.minecraft.core.net.packet.PreLoginPacket;
+import net.minecraft.core.net.packet.RecipeSyncPacket;
+import net.minecraft.core.net.packet.RemoveEntityPacket;
+import net.minecraft.core.net.packet.RespawnPacket;
+import net.minecraft.core.net.packet.SetCarriedItemPacket;
+import net.minecraft.core.net.packet.SetEntityMotionPacket;
+import net.minecraft.core.net.packet.SetEquippedItemPacket;
+import net.minecraft.core.net.packet.SetHealthPacket;
+import net.minecraft.core.net.packet.SetMobSpawnerPacket;
+import net.minecraft.core.net.packet.SetRidingPacket;
+import net.minecraft.core.net.packet.SetSpawnPositionPacket;
+import net.minecraft.core.net.packet.SetTimePacket;
+import net.minecraft.core.net.packet.SleepPacket;
+import net.minecraft.core.net.packet.StatisticPacket;
+import net.minecraft.core.net.packet.SyncIDsPacket;
+import net.minecraft.core.net.packet.TakeItemEntityPacket;
+import net.minecraft.core.net.packet.TeleportEntityPacket;
+import net.minecraft.core.net.packet.BlockEntityDataPacket;
+import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
+import net.minecraft.core.net.packet.WeatherEffectPacket;
+import net.minecraft.core.net.packet.WeatherStatusPacket;
+import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.inventory.menu.AbstractContainerMenu;
+import net.minecraft.core.player.inventory.container.SimpleContainer;
+import net.minecraft.core.sound.SoundTypes;
+import net.minecraft.core.util.helper.AES;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.RSA;
+import net.minecraft.core.world.Explosion;
+import net.minecraft.core.world.ExplosionCannonball;
+import net.minecraft.core.world.IVehicle;
+import net.minecraft.core.world.chunk.ChunkCoordinates;
+import net.minecraft.core.world.save.LevelData;
+import net.minecraft.core.world.saveddata.SavedDataStorage;
+import net.minecraft.core.world.weather.Weather;
+import net.minecraft.core.world.weather.Weathers;
+
+import java.io.BufferedReader;
+import java.io.IOException;
+import java.io.InputStreamReader;
+import java.net.InetAddress;
+import java.net.Socket;
+import java.net.URL;
+import java.net.UnknownHostException;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Random;
+
+public class ClientPacketHandler extends PacketHandler
+{
+    private boolean disconnected;
+    private final NetworkManager netManager;
+    public String message; // Name from b1.2 leak
+    private final Minecraft mc;
+    private WorldClient worldClient;
+    private boolean started; // Name from b1.2 leak
+    public SavedDataStorage savedDataStorage;
+    public List<PlayerProfile> players;
+    public HashMap<String, String> playerList = new HashMap<>();
+    Random rand;
+
+    public ClientPacketHandler(Minecraft minecraft, String host, int port)
+            throws UnknownHostException, IOException
+    {
+        disconnected = false;
+        started = false;
+        savedDataStorage = new SavedDataStorage(null);
+        rand = new Random();
+        mc = minecraft;
+        Socket socket = new Socket(InetAddress.getByName(host), port);
+        netManager = new NetworkManager(socket, "Client", this);
+        players = new ArrayList<>();
+    }
+
+    public void tick()
+    {
+        if (!disconnected)
+        {
+            netManager.processReadPackets();
+        }
+        netManager.wakeThreads();
+    }
+
+    public int findPlayerInList(PlayerProfile playerProfile)
+    {
+        for (int i = 0; i < players.size(); i++)
+        {
+            if (players.get(i).playerName.equals(playerProfile.playerName))
+            {
+                return i;
+            }
+        }
+        return -1;
+    }
+
+    public void addPlayer(PlayerProfile playerProfile)
+    {
+        players.add(playerProfile);
+    }
+
+    public PlayerProfile getPlayer(String username)
+    {
+        for (PlayerProfile player : players)
+        {
+            if (player.playerName.equals(username))
+            {
+                return player;
+            }
+        }
+
+        return null;
+    }
+
+    public void removePlayer(int index)
+    {
+        players.remove(index);
+    }
+
+
+    @Override
+    public void handleLogin(LoginPacket loginPacket)
+    {
+        mc.playerController = new PlayerControllerMP(mc, this);
+        mc.statsCounter.add(StatList.joinMultiplayerStat, 1);
+        worldClient = new WorldClient(mc, this, loginPacket.worldSeed, loginPacket.dimensionId, loginPacket.worldTypeId);
+        worldClient.isClientSide = true;
+        mc.changeWorld(worldClient);
+        mc.thePlayer.dimension = loginPacket.dimensionId;
+        mc.displayGuiScreen(new GuiDownloadTerrain(this));
+        mc.thePlayer.id = loginPacket.playerEntityIdAndProtocolVersion;
+        NetworkManager.PACKET_DELAY = loginPacket.packetDelay;
+        Registries.RECIPES = new RecipeRegistry();
+    }
+
+    @Override
+    public void handlePickupSpawn(AddItemEntityPacket addItemEntityPacket21Pickupspawn)
+    {
+        double x = addItemEntityPacket21Pickupspawn.xPosition / 32D;
+        double y = addItemEntityPacket21Pickupspawn.yPosition / 32D;
+        double z = addItemEntityPacket21Pickupspawn.zPosition / 32D;
+        ItemEntity entityitem = new ItemEntity(worldClient, x, y, z, new ItemStack(addItemEntityPacket21Pickupspawn.itemID, addItemEntityPacket21Pickupspawn.count, addItemEntityPacket21Pickupspawn.itemDamage, addItemEntityPacket21Pickupspawn.tag));
+        entityitem.xd = (double) addItemEntityPacket21Pickupspawn.xd / 128D;
+        entityitem.yd = (double) addItemEntityPacket21Pickupspawn.yd / 128D;
+        entityitem.zd = (double) addItemEntityPacket21Pickupspawn.zd / 128D;
+        entityitem.serverPosX = addItemEntityPacket21Pickupspawn.xPosition;
+        entityitem.serverPosY = addItemEntityPacket21Pickupspawn.yPosition;
+        entityitem.serverPosZ = addItemEntityPacket21Pickupspawn.zPosition;
+        worldClient.addEntityToWorld(addItemEntityPacket21Pickupspawn.entityId, entityitem);
+    }
+
+
+    @Override
+    public void handleVehicleSpawn(AddEntityPacket packet23) {
+        if (!NetEntityHandler.hasType(packet23.type)){ return; }
+        double xPosition = ((double) packet23.xPosition) / 32D;
+        double yPosition = ((double) packet23.yPosition) / 32D;
+        double zPosition = ((double) packet23.zPosition) / 32D;
+        Entity owner;
+        if (packet23.ownerId >= 0){
+            owner = getEntityByID(packet23.ownerId);
+        } else {
+            owner = null;
+        }
+        Entity newEntity = NetEntityHandler.getTypeEntry(packet23.type).getEntity(worldClient, xPosition, yPosition, zPosition, packet23.metaData, packet23.hasVelocity, packet23.xVelocity / 8000D, packet23.yVelocity / 8000D, packet23.zVelocity / 8000D, owner);
+        if (newEntity != null) {
+            newEntity.serverPosX = packet23.xPosition;
+            newEntity.serverPosY = packet23.yPosition;
+            newEntity.serverPosZ = packet23.zPosition;
+            newEntity.yRot = packet23.yaw;
+            newEntity.xRot = packet23.pitch;
+            newEntity.id = packet23.entityId;
+            worldClient.addEntityToWorld(packet23.entityId, newEntity);
+            if (owner instanceof Mob && newEntity instanceof Projectile){
+                ((Projectile) newEntity).owner = (Mob) owner;
+            }
+            if (packet23.hasVelocity){
+                newEntity.lerpMotion(((double) packet23.xVelocity) / 8000D, ((double) packet23.yVelocity) / 8000D, ((double) packet23.zVelocity) / 8000D);
+            }
+        }
+    }
+
+    @Override
+    public void handleWeather(WeatherEffectPacket weatherEffectPacket)
+    {
+        double x = (double) weatherEffectPacket.x / 32D;
+        double y = (double) weatherEffectPacket.y / 32D;
+        double z = (double) weatherEffectPacket.z / 32D;
+        Entity weatherEntity = null;
+        if (weatherEffectPacket.effectId == WeatherEffectPacket.EFFECT_LIGHTNING) {
+            weatherEntity = new LightningEntity(worldClient, x, y, z);
+        }
+        if (weatherEntity != null)
+        {
+            weatherEntity.serverPosX = weatherEffectPacket.x;
+            weatherEntity.serverPosY = weatherEffectPacket.y;
+            weatherEntity.serverPosZ = weatherEffectPacket.z;
+            weatherEntity.yRot = 0.0F;
+            weatherEntity.xRot = 0.0F;
+            weatherEntity.id = weatherEffectPacket.id;
+            worldClient.addWeatherEffect(weatherEntity);
+        }
+    }
+
+    @Override
+    public void handleWeatherStatus(WeatherStatusPacket packet)
+    {
+        if (worldClient.dimension.id != packet.dimId) return;
+        Weather currentWeather = packet.id == -1 ? null : Weathers.WEATHERS[packet.id];
+        Weather newWeather = packet.newId == -1 ? null : Weathers.WEATHERS[packet.newId];
+        worldClient.weatherManager.overrideWeather(currentWeather, newWeather, packet.duration, packet.intensity, packet.power);
+    }
+
+    @Override
+    public void handleEntityPainting(AddPaintingPacket packet)
+    {
+        Entity entity = worldClient.getEntityFromId(packet.entityId);
+        if (entity instanceof PaintingEntity){
+            PaintingEntity painting = (PaintingEntity) entity;
+            painting.blockX = packet.xPosition;
+            painting.blockY = packet.yPosition;
+            painting.blockZ = packet.zPosition;
+
+            if (ArtType.map.containsKey(packet.key)) painting.art = ArtType.map.get(packet.key);
+
+            painting.setDirection(packet.direction);
+            if (packet.itemID > 0){
+                painting.setStack(new ItemStack(packet.itemID, 1, packet.meta));
+            }
+        } else {
+            PaintingEntity entitypainting = new PaintingEntity(worldClient, packet.xPosition, packet.yPosition, packet.zPosition, packet.direction, packet.key);
+            worldClient.addEntityToWorld(packet.entityId, entitypainting);
+            if (packet.itemID > 0){
+                entitypainting.setStack(new ItemStack(packet.itemID, 1, packet.meta));
+            }
+        }
+
+    }
+
+    @Override
+    public void handleEntityVelocity(SetEntityMotionPacket setEntityvelocity)
+    {
+        Entity entity = getEntityByID(setEntityvelocity.entityId);
+        if (entity == null)
+        {
+            return;
+        }
+        else
+        {
+            entity.lerpMotion((double) setEntityvelocity.motionX / 8000D, (double) setEntityvelocity.motionY / 8000D, (double) setEntityvelocity.motionZ / 8000D);
+            return;
+        }
+    }
+
+    @Override
+    public void handleEntityMetadata(SetEntityDataPacket entitymetadata)
+    {
+        Entity entity = getEntityByID(entitymetadata.entityId);
+        if (entity != null && entitymetadata.getUnpackedData() != null)
+        {
+            entity.getEntityData().assignValues(entitymetadata.getUnpackedData());
+        }
+    }
+
+    @Override
+    public void handleNamedEntitySpawn(AddPlayerPacket addPlayerPacket20Namedentityspawn)
+    {
+        double d = (double) addPlayerPacket20Namedentityspawn.xPosition / 32D;
+        double d1 = (double) addPlayerPacket20Namedentityspawn.yPosition / 32D;
+        double d2 = (double) addPlayerPacket20Namedentityspawn.zPosition / 32D;
+        float f = (float) (addPlayerPacket20Namedentityspawn.rotation * 360) / 256F;
+        float f1 = (float) (addPlayerPacket20Namedentityspawn.pitch * 360) / 256F;
+        RemotePlayer entityotherplayermp = new RemotePlayer(mc.theWorld, addPlayerPacket20Namedentityspawn.name);
+        entityotherplayermp.xo = entityotherplayermp.serverPosX = addPlayerPacket20Namedentityspawn.xPosition;
+        entityotherplayermp.yo = entityotherplayermp.serverPosY = addPlayerPacket20Namedentityspawn.yPosition;
+        entityotherplayermp.zo = entityotherplayermp.serverPosZ = addPlayerPacket20Namedentityspawn.zPosition;
+        int i = addPlayerPacket20Namedentityspawn.currentItem;
+        if (i == 0)
+        {
+            entityotherplayermp.inventory.mainInventory[entityotherplayermp.inventory.currentItem] = null;
+        }
+        else
+        {
+            entityotherplayermp.inventory.mainInventory[entityotherplayermp.inventory.currentItem] = new ItemStack(i, 1, 0);
+        }
+        entityotherplayermp.absMoveTo(d, d1, d2, f, f1);
+        worldClient.addEntityToWorld(addPlayerPacket20Namedentityspawn.entityId, entityotherplayermp);
+        entityotherplayermp.nickname = StringUtils.substring(addPlayerPacket20Namedentityspawn.nickname, 0, 32);
+        entityotherplayermp.chatColor = addPlayerPacket20Namedentityspawn.chatColor;
+    }
+
+    @Override
+    public void handleEntityTeleport(TeleportEntityPacket packet34EntityteleportEntityPacket)
+    {
+        Entity entity = getEntityByID(packet34EntityteleportEntityPacket.id);
+        if (entity == null)
+        {
+            return;
+        }
+        else
+        {
+            entity.serverPosX = packet34EntityteleportEntityPacket.x;
+            entity.serverPosY = packet34EntityteleportEntityPacket.y;
+            entity.serverPosZ = packet34EntityteleportEntityPacket.z;
+            double d = (double) entity.serverPosX / 32D;
+            double d1 = (double) entity.serverPosY / 32D + 0.015625D;
+            double d2 = (double) entity.serverPosZ / 32D;
+            float f = (float) (packet34EntityteleportEntityPacket.yaw * 360) / 256F;
+            float f1 = (float) (packet34EntityteleportEntityPacket.pitch * 360) / 256F;
+            entity.lerpTo(d, d1, d2, f, f1, 3);
+            return;
+        }
+    }
+
+    @Override
+    public void handleEntity(MoveEntityPacket moveEntityPacket)
+    {
+        Entity entity = getEntityByID(moveEntityPacket.id);
+        if (entity == null)
+        {
+            return;
+        }
+        else
+        {
+            entity.serverPosX += moveEntityPacket.x;
+            entity.serverPosY += moveEntityPacket.y;
+            entity.serverPosZ += moveEntityPacket.z;
+            double d = (double) entity.serverPosX / 32D;
+            double d1 = (double) entity.serverPosY / 32D;
+            double d2 = (double) entity.serverPosZ / 32D;
+            float f = moveEntityPacket.rotating ? (float) (moveEntityPacket.yaw * 360) / 256F : entity.yRot;
+            float f1 = moveEntityPacket.rotating ? (float) (moveEntityPacket.pitch * 360) / 256F : entity.xRot;
+            entity.lerpTo(d, d1, d2, f, f1, 3);
+            return;
+        }
+    }
+
+    @Override
+    public void handleEntityTagData(EntityTagDataPacket packet) {
+        Entity entity = getEntityByID(packet.entityId);
+        if (entity != null) {
+            entity.readAdditionalSaveData(packet.tag);
+        }
+    }
+
+    @Override
+    public void handleSetMobSpawner(SetMobSpawnerPacket setMobSpawnerPacket)
+    {
+        if (mc.theWorld.isBlockLoaded(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition))
+        {
+            BlockEntity tileentity = mc.theWorld.getBlockEntity(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition);
+            if (tileentity instanceof MobSpawnerBlockEntity)
+            {
+                MobSpawnerBlockEntity tileEntityMobSpawner = (MobSpawnerBlockEntity) tileentity;
+                tileEntityMobSpawner.setMobId(setMobSpawnerPacket.spawnType);
+
+                tileEntityMobSpawner.setChanged();
+            }
+        }
+    }
+
+    @Override
+    public void handleDestroyEntity(RemoveEntityPacket packet29DestroyentityPacket)
+    {
+        worldClient.removeEntityFromWorld(packet29DestroyentityPacket.entityId);
+    }
+
+    @Override
+    public void handleFlying(MovePlayerPacket movePlayerPacket)
+    {
+        LocalPlayer entityplayersp = mc.thePlayer;
+        double d = ((Player) (entityplayersp)).x;
+        double d1 = ((Player) (entityplayersp)).y;
+        double d2 = ((Player) (entityplayersp)).z;
+        float f = ((Player) (entityplayersp)).yRot;
+        float f1 = ((Player) (entityplayersp)).xRot;
+        if (movePlayerPacket.hasPosition)
+        {
+            d = movePlayerPacket.x;
+            d1 = movePlayerPacket.y;
+            d2 = movePlayerPacket.z;
+        }
+        if (movePlayerPacket.hasRotation)
+        {
+            f = movePlayerPacket.yaw;
+            f1 = movePlayerPacket.pitch;
+        }
+        entityplayersp.ySlideOffset = 0.0F;
+        entityplayersp.xd = entityplayersp.yd = entityplayersp.zd = 0.0D;
+        entityplayersp.absMoveTo(d, d1, d2, f, f1);
+        movePlayerPacket.x = ((Player) (entityplayersp)).x;
+        movePlayerPacket.y = ((Player) (entityplayersp)).bb.minY;
+        movePlayerPacket.z = ((Player) (entityplayersp)).z;
+        movePlayerPacket.yView = ((Player) (entityplayersp)).y;
+        netManager.addToSendQueue(movePlayerPacket);
+        if (!started)
+        {
+            mc.thePlayer.xo = mc.thePlayer.x;
+            mc.thePlayer.yo = mc.thePlayer.y;
+            mc.thePlayer.zo = mc.thePlayer.z;
+            started = true;
+            mc.displayGuiScreen(null);
+        }
+    }
+
+    @Override
+    public void handlePreChunk(ChunkVisibilityPacket packet50PrechunkVisibilityPacket)
+    {
+        worldClient.doPreChunk(packet50PrechunkVisibilityPacket.xPosition, packet50PrechunkVisibilityPacket.yPosition, packet50PrechunkVisibilityPacket.mode);
+    }
+
+    @Override
+    public void handleMultiBlockChange(ChunkBlocksUpdatePacket packet)
+    {
+        int xBase = packet.xChunk * 16;
+        int zBase = packet.zChunk * 16;
+        for (int k = 0; k < packet.size; k++)
+        {
+            int coord = packet.coordinateArray[k];
+            int type = packet.typeArray[k] & 0x3fff;
+            byte data = packet.metadataArray[k];
+            int x = coord >> 0 & 0xf;
+            int y = coord >> 8 & 0xff;
+            int z = coord >> 4 & 0xf;
+            worldClient.setBlockAndMetadataWithNotify(x + xBase, y, z + zBase, type, data);
+            worldClient.func_711_c(x + xBase, y, z + zBase, x + xBase, y, z + zBase);
+            worldClient.markBlocksDirty(x + xBase, y, z + zBase, x + xBase, y, z + zBase);
+        }
+
+    }
+
+    @Override
+    public void handleMapChunk(BlockRegionUpdatePacket packet)
+    {
+        worldClient.func_711_c(packet.xPosition, packet.yPosition, packet.zPosition, (packet.xPosition + packet.xSize) - 1, (packet.yPosition + packet.ySize) - 1, (packet.zPosition + packet.zSize) - 1);
+        worldClient.setChunkData(packet.xPosition, packet.yPosition, packet.zPosition, packet.xSize, packet.ySize, packet.zSize, packet.chunk);
+    }
+
+    @Override
+    public void handleBlockChange(BlockUpdatePacket blockchange)
+    {
+        worldClient.blockChange(blockchange.xPosition, blockchange.yPosition, blockchange.zPosition, blockchange.type, blockchange.metadata);
+    }
+
+    @Override
+    public void handleKickDisconnect(DisconnectPacket packet255KickdisconnectPacket)
+    {
+        netManager.networkShutdown("disconnect.kicked", new Object[0]);
+        disconnected = true;
+        mc.changeWorld(null);
+        mc.displayGuiScreen(new GuiConnectFailed("disconnect.disconnected", "disconnect.genericReason", new Object[]{
+            packet255KickdisconnectPacket.reason
+        }));
+    }
+
+    @Override
+    public void handleErrorMessage(String s, Object[] errorLines)
+    {
+        if (!disconnected) {
+            disconnected = true;
+            mc.changeWorld(null);
+            mc.displayGuiScreen(new GuiConnectFailed("disconnect.lost", s, errorLines));
+        }
+    }
+
+    public void func_28117_a(Packet packet)
+    {
+        if (disconnected)
+        {
+            return;
+        }
+        else
+        {
+            netManager.addToSendQueue(packet);
+            netManager.serverShutdown();
+            return;
+        }
+    }
+
+    public void addToSendQueue(Packet packet)
+    {
+        if (!disconnected) {
+            netManager.addToSendQueue(packet);
+        }
+    }
+
+    @Override
+    public void handleCollect(TakeItemEntityPacket takeItemEntityPacket)
+    {
+        Entity entity = getEntityByID(takeItemEntityPacket.collectedEntityId);
+        Object obj = (Mob) getEntityByID(takeItemEntityPacket.collectorEntityId);
+        if (obj == null)
+        {
+            obj = mc.thePlayer;
+        }
+        if (entity != null)
+        {
+            // this class does not seem to handle pick up from server dropped items. find where it is.
+            // something about that isn't working on servers if the player changed their gamemode.
+            worldClient.playSoundAtEntity(null, entity, "random.pop", 0.2F, ((rand.nextFloat() - rand.nextFloat()) * 0.7F + 1.0F) * 2.0F);
+            mc.effectRenderer.addEffect(new TakeAnimationParticle(mc.theWorld, entity, ((Entity) (obj)), -0.5F));
+            worldClient.removeEntityFromWorld(takeItemEntityPacket.collectedEntityId);
+        }
+    }
+
+	@Override
+	public void handleChat(ChatPacket packet) {
+		String message;
+		if(packet.encrypted) {
+			try {
+				message = AES.decrypt(packet.message, AES.clientKeyChain);
+			}catch (Exception e) {
+				throw new RuntimeException(ChatPacket.ENCRYPTION_ERROR_MESSAGE, e);
+			}
+		}else {
+			message = packet.message;
+		}
+		
+		int type = packet.type;
+		if(type == 1) {
+			mc.ingameGUI.guiHeldItemTooltip.setString(message);
+		}else {
+			mc.ingameGUI.addChatMessage(message);
+		}
+	}
+
+    public void handlePlayerJoin(ChatPacket chatPacket)
+    {
+        mc.ingameGUI.addChatMessage(chatPacket.message);
+    }
+
+    public void handlePlayerLeave(ChatPacket chatPacket)
+    {
+        mc.ingameGUI.addChatMessage(chatPacket.message);
+    }
+
+    @Override
+    public void handleAnimation(AnimatePacket animatePacket)
+    {
+        Entity entity = getEntityByID(animatePacket.entityId);
+        if (entity == null)
+        {
+            return;
+        }
+        if (animatePacket.animate == 1)
+        {
+            Player entityplayer = (Player) entity;
+            entityplayer.swingItem();
+        }
+        else if (animatePacket.animate == 2)
+        {
+            entity.animateHurt();
+        }
+        else if (animatePacket.animate == 3)
+        {
+            Player entityplayer1 = (Player) entity;
+            entityplayer1.wakeUpPlayer(false, false);
+        }
+        else if (animatePacket.animate == 4)
+        {
+            Player entityplayer2 = (Player) entity;
+            entityplayer2.func_6420_o();
+        }
+    }
+
+    @Override
+    public void handleSleep(SleepPacket sleepPacket)
+    {
+        Entity entity = getEntityByID(sleepPacket.entityID);
+        if (entity == null)
+        {
+            return;
+        }
+        if (sleepPacket.field_22046_e == 0)
+        {
+            Player entityplayer = (Player) entity;
+            entityplayer.sleepInBedAt(sleepPacket.x, sleepPacket.y, sleepPacket.z);
+        }
+    }
+
+    @Override
+    public void handleHandshake(PreLoginPacket preLoginPacket)
+    {
+        if (preLoginPacket.username.equals("-"))
+        {
+            try
+            {
+                RSA.RSAKeyChain = RSA.generateKeyPair();
+                addToSendQueue(new LoginPacket(mc.session.username, Global.MP_PROTOCOL_VERSION, RSA.getPublicKey(RSA.RSAKeyChain.getPublic())));
+            }
+            catch (Exception e)
+            {
+                throw new RuntimeException(e);
+            }
+        }
+        else
+        {
+            try
+            {
+                URL url = new URL("http://session.minecraft.net/game/joinserver.jsp?user=" + mc.session.username + "&sessionId=" + mc.session.sessionId + "&serverId=" + preLoginPacket.username);
+                BufferedReader bufferedreader = new BufferedReader(new InputStreamReader(url.openStream()));
+                String s = bufferedreader.readLine();
+                bufferedreader.close();
+                if (s.equalsIgnoreCase("ok"))
+                {
+                    try
+                    {
+                        RSA.RSAKeyChain = RSA.generateKeyPair();
+                        addToSendQueue(new LoginPacket(mc.session.username, Global.MP_PROTOCOL_VERSION, RSA.getPublicKey(RSA.RSAKeyChain.getPublic())));
+                    }
+                    catch (Exception e)
+                    {
+                        throw new RuntimeException(e);
+                    }
+                }
+                else
+                {
+                    netManager.networkShutdown("disconnect.loginFailedInfo", new Object[]{
+                            s
+                    });
+                }
+            }
+            catch (Exception exception)
+            {
+                exception.printStackTrace();
+                netManager.networkShutdown("disconnect.genericReason", new Object[]{
+                        "Internal client error: " + exception.toString()
+                });
+            }
+        }
+    }
+
+    @Override
+    public void handleSendKey(AESSendKeyPacket AESSendKeyPacket)
+    {
+        try
+        {
+            AES.clientKeyChain = AES.getKey(RSA.decrypt(AESSendKeyPacket.KEY, RSA.RSAKeyChain.getPrivate()));
+        }
+        catch (Exception e)
+        {
+            throw new RuntimeException(e);
+        }
+    }
+
+    @Override
+    public void handlePlayerList(PlayerListPacket playerListPacket)
+    {
+        playerList.clear();
+        String[] players = playerListPacket.players;
+        String[] scores = playerListPacket.scores;
+        for (int i = 0; i < players.length; i++)
+        {
+            playerList.put(players[i], scores[i]);
+        }
+    }
+
+    public void disconnect()
+    {
+        disconnected = true;
+        netManager.wakeThreads();
+        netManager.networkShutdown("disconnect.closed", new Object[0]);
+    }
+
+    @Override
+    public void handleMobSpawn(AddMobPacket addMobspawn)
+    {
+        double d = (double) addMobspawn.x / 32D;
+        double d1 = (double) addMobspawn.y / 32D;
+        double d2 = (double) addMobspawn.z / 32D;
+        float f = (float) (addMobspawn.yaw * 360) / 256F;
+        float f1 = (float) (addMobspawn.pitch * 360) / 256F;
+        Mob entityliving = (Mob) EntityDispatcher.createEntity(addMobspawn.type, mc.theWorld);
+        entityliving.serverPosX = addMobspawn.x;
+        entityliving.serverPosY = addMobspawn.y;
+        entityliving.serverPosZ = addMobspawn.z;
+        entityliving.id = addMobspawn.id;
+        entityliving.absMoveTo(d, d1, d2, f, f1);
+        entityliving.isMultiplayerEntity = true;
+        worldClient.addEntityToWorld(addMobspawn.id, entityliving);
+        java.util.List list = addMobspawn.getUnpackedData();
+        if (list != null)
+        {
+            entityliving.getEntityData().assignValues(list);
+        }
+        entityliving.nickname = StringUtils.substring(addMobspawn.nickname, 0, 32);
+        entityliving.chatColor = addMobspawn.chatColor;
+    }
+
+    @Override
+    public void handleUpdateTime(SetTimePacket packet4UpdatetimePacket)
+    {
+        mc.theWorld.setWorldTime(packet4UpdatetimePacket.time);
+    }
+
+    @Override
+    public void handleSpawnPosition(SetSpawnPositionPacket setSpawnpositionPacket)
+    {
+        mc.thePlayer.setPlayerSpawnCoordinate(new ChunkCoordinates(setSpawnpositionPacket.x, setSpawnpositionPacket.y, setSpawnpositionPacket.z));
+        mc.theWorld.getLevelData().setSpawn(setSpawnpositionPacket.x, setSpawnpositionPacket.y, setSpawnpositionPacket.z);
+    }
+
+    @Override
+    public void handleAttachEntity(SetRidingPacket packet)
+    {
+        Entity passenger = getEntityByID(packet.passengerId);
+        IVehicle vehicle;
+        if (packet.passengerId == mc.thePlayer.id)
+        {
+            passenger = mc.thePlayer;
+        }
+        if (packet.isTileEntity) {
+            vehicle = (IVehicle) worldClient.getBlockEntity(packet.x, packet.y, packet.z);
+        } else {
+            vehicle = getEntityByID(packet.vehicleId);
+        }
+        if (passenger != null && vehicle != null) {
+            passenger.startRiding(vehicle);
+        }
+    }
+
+    @Override
+    public void handleEntityStatus(EnitityEventPacket enitityEventPacket38Entitystatus)
+    {
+        Entity entity = getEntityByID(enitityEventPacket38Entitystatus.entityId);
+        if (entity != null)
+        {
+            entity.handleEntityEvent(enitityEventPacket38Entitystatus.entityStatus, enitityEventPacket38Entitystatus.attackedAtYaw);
+        }
+    }
+
+    protected Entity getEntityByID(int i)
+    {
+        if (i == mc.thePlayer.id)
+        {
+            return mc.thePlayer;
+        }
+        else
+        {
+            return worldClient.getEntityFromId(i);
+        }
+    }
+
+    @Override
+    public void handleUpdateHealth(SetHealthPacket packet8UpdatehealthPacket)
+    {
+        mc.thePlayer.setHealth(packet8UpdatehealthPacket.healthMP);
+    }
+
+    @Override
+    public void handleUpdatePlayerProfile(UpdatePlayerProfilePacket packet72playerprofile)
+    {
+        PlayerProfile playerProfile = new PlayerProfile(packet72playerprofile.username, packet72playerprofile.nickname, packet72playerprofile.score, packet72playerprofile.chatColor, packet72playerprofile.isOperator);
+        if (playerProfile.playerName.equals(mc.thePlayer.username))
+        {
+            mc.thePlayer.score = playerProfile.scoreTotal;
+        }
+        int index = findPlayerInList(playerProfile);
+        if (index != -1)
+        {
+            if (!packet72playerprofile.isOnline)
+            {
+                removePlayer(index);
+            }
+            else
+            {
+                players.set(index, playerProfile);
+            }
+        }
+        else
+        {
+            addPlayer(playerProfile);
+        }
+    }
+
+    @Override
+    public void handleRespawn(RespawnPacket respawnPacket)
+    {
+        if (respawnPacket.respawnDimensionId != mc.thePlayer.dimension)
+        {
+            started = false;
+            worldClient = new WorldClient(mc, this, worldClient.getLevelData().getRandomSeed(), respawnPacket.respawnDimensionId, respawnPacket.respawnWorldTypeId);
+            worldClient.isClientSide = true;
+            mc.changeWorld(worldClient);
+            mc.thePlayer.dimension = respawnPacket.respawnDimensionId;
+            mc.displayGuiScreen(new GuiDownloadTerrain(this));
+        }
+        mc.respawn(true, respawnPacket.respawnDimensionId);
+    }
+
+    @Override
+    public void handleExplosion(ExplosionPacket explosionPacket)
+    {
+        Explosion explosion;
+        if (explosionPacket.isCannonball)
+        {
+            explosion = new ExplosionCannonball(mc.theWorld, null, explosionPacket.explosionX, explosionPacket.explosionY, explosionPacket.explosionZ, explosionPacket.explosionSize);
+        }
+        else
+        {
+            explosion = new Explosion(mc.theWorld, null, explosionPacket.explosionX, explosionPacket.explosionY, explosionPacket.explosionZ, explosionPacket.explosionSize);
+        }
+        explosion.destroyedBlockPositions = explosionPacket.destroyedBlockPositions;
+        //explosion.doExplosionA();
+        explosion.addEffects(true);
+    }
+
+    @Override
+    public void handleOpenWindow(ContainerOpenPacket containerOpenwindow)
+    {
+        if (containerOpenwindow.inventoryType == 0)
+        {
+            SimpleContainer inventorybasic = new SimpleContainer(containerOpenwindow.windowTitle, containerOpenwindow.slotsCount);
+            mc.thePlayer.displayGUIChest(inventorybasic);
+            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+        }
+        else if (containerOpenwindow.inventoryType == 2)
+        {
+            FurnaceBlockEntity tileentityfurnace = new FurnaceBlockEntity();
+            mc.thePlayer.displayGUIFurnace(tileentityfurnace);
+            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+        }
+        else if (containerOpenwindow.inventoryType == 3)
+        {
+            DispenserBlockEntity tileentitydispenser = new DispenserBlockEntity();
+            mc.thePlayer.displayGUIDispenser(tileentitydispenser);
+            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+        }
+        else if (containerOpenwindow.inventoryType == 4)
+        {
+            BlastFurnaceBlockEntity tileentityblastfurnace = new BlastFurnaceBlockEntity();
+            mc.thePlayer.displayGUIFurnace(tileentityblastfurnace);
+            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+        }
+        else if (containerOpenwindow.inventoryType == 5)
+        {
+            TrommelBlockEntity tileentitytrommel = new TrommelBlockEntity();
+            mc.thePlayer.displayGUITrommel(tileentitytrommel);
+            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+        }
+        else if (containerOpenwindow.inventoryType == 7)
+        {
+            mc.thePlayer.displayGUIPaintingPicker();
+        }
+        else if (containerOpenwindow.inventoryType == 1)
+        {
+            LocalPlayer entityplayersp = mc.thePlayer;
+            mc.thePlayer.displayGUIWorkbench(MathHelper.floor(entityplayersp.x), MathHelper.floor(entityplayersp.y), MathHelper.floor(entityplayersp.z));
+            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+        }
+    }
+
+    @Override
+    public void handleOpenFlagWindow(FlagOpenPacket packet)
+    {
+        BlockEntity blockEntity = worldClient.getBlockEntity(packet.x, packet.y, packet.z);
+        if (blockEntity instanceof FlagBlockEntity)
+        {
+            FlagBlockEntity tileEntityFlag = (FlagBlockEntity) blockEntity;
+            mc.thePlayer.displayGUIEditFlag(tileEntityFlag);
+            mc.thePlayer.craftingInventory.containerId = packet.windowId;
+        }
+    }
+
+    @Override
+    public void handlePhotoMode(PhotoModePacket packet)
+    {
+        GuiIngameMenu.photoModeDisabled = packet.disabled;
+    }
+
+    @Override
+    public void handleSetSlot(ContainerSetSlotPacket containerSetslotPacket)
+    {
+        if (containerSetslotPacket.windowId == -1)
+        {
+            mc.thePlayer.inventory.setHeldItemStack(containerSetslotPacket.myItemStack);
+        }
+        else if (containerSetslotPacket.windowId == 0 && containerSetslotPacket.itemSlot >= 36 && containerSetslotPacket.itemSlot < 45)
+        {
+            ItemStack itemstack = mc.thePlayer.inventorySlots.getSlot(containerSetslotPacket.itemSlot).getItem();
+            if (containerSetslotPacket.myItemStack != null && (itemstack == null || itemstack.stackSize < containerSetslotPacket.myItemStack.stackSize))
+            {
+                containerSetslotPacket.myItemStack.animationsToGo = 5;
+            }
+            mc.thePlayer.inventorySlots.setItem(containerSetslotPacket.itemSlot, containerSetslotPacket.myItemStack);
+        }
+        else if (containerSetslotPacket.windowId == mc.thePlayer.craftingInventory.containerId)
+        {
+            mc.thePlayer.craftingInventory.setItem(containerSetslotPacket.itemSlot, containerSetslotPacket.myItemStack);
+        }
+    }
+
+    @Override
+    public void handleTransaction(ContainerAckPacket containerAckPacket)
+    {
+        AbstractContainerMenu container = null;
+        if (containerAckPacket.windowId == 0)
+        {
+            container = mc.thePlayer.inventorySlots;
+        }
+        else if (containerAckPacket.windowId == mc.thePlayer.craftingInventory.containerId)
+        {
+            container = mc.thePlayer.craftingInventory;
+        }
+        if (container != null)
+        {
+            if (containerAckPacket.accepted)
+            {
+                container.deleteBackup(containerAckPacket.shortWindowId);
+            }
+            else
+            {
+                container.rollbackToBackup(containerAckPacket.shortWindowId);
+                addToSendQueue(new ContainerAckPacket(containerAckPacket.windowId, containerAckPacket.shortWindowId, true));
+            }
+        }
+    }
+
+    @Override
+    public void handleWindowItems(ContainerSetContentPacket containerSetContentPacket104Windowitems)
+    {
+        if (containerSetContentPacket104Windowitems.windowId == 0)
+        {
+            mc.thePlayer.inventorySlots.setAll(containerSetContentPacket104Windowitems.stackList);
+        }
+        else if (containerSetContentPacket104Windowitems.windowId == mc.thePlayer.craftingInventory.containerId)
+        {
+            mc.thePlayer.craftingInventory.setAll(containerSetContentPacket104Windowitems.stackList);
+        }
+    }
+
+    @Override
+    public void handleUpdateProgressbar(ContainerSetDataPacket containerSetDataPacket105Updateprogressbar)
+    {
+        handleInvalidPacket(containerSetDataPacket105Updateprogressbar);
+        if (mc.thePlayer.craftingInventory != null && mc.thePlayer.craftingInventory.containerId == containerSetDataPacket105Updateprogressbar.windowId)
+        {
+            mc.thePlayer.craftingInventory.setData(containerSetDataPacket105Updateprogressbar.progressBar, containerSetDataPacket105Updateprogressbar.progressBarValue);
+        }
+    }
+
+    @Override
+    public void handlePlayerInventory(SetEquippedItemPacket setEquippedItemPacket5Playerinventory)
+    {
+        Entity entity = getEntityByID(setEquippedItemPacket5Playerinventory.entityID);
+        if (entity != null)
+        {
+            entity.setEquippedSlot(setEquippedItemPacket5Playerinventory.slot, setEquippedItemPacket5Playerinventory.itemID, setEquippedItemPacket5Playerinventory.itemMeta, setEquippedItemPacket5Playerinventory.itemData);
+        }
+    }
+
+    @Override
+    public void handleCloseWindow(ContainerClosePacket containerClosewindow)
+    {
+        mc.thePlayer.closeScreen();
+    }
+
+    @Override
+    public void handlePlayNoteBlock(BlockEventPacket packet54PlaynoteblockEventPacket)
+    {
+        mc.theWorld.triggerEvent(packet54PlaynoteblockEventPacket.xLocation, packet54PlaynoteblockEventPacket.yLocation, packet54PlaynoteblockEventPacket.zLocation, packet54PlaynoteblockEventPacket.instrumentType, packet54PlaynoteblockEventPacket.pitch);
+    }
+
+    // TODO
+    // todo what?
+    @Override
+    public void handleBed(BedMessagePacket bedMessagePacket)
+    {
+        int state = bedMessagePacket.bedState;
+        if (state >= 0 && state < BedMessagePacket.BED_MESSAGE_KEYS.length && BedMessagePacket.BED_MESSAGE_KEYS[state] != null)
+        {
+            mc.thePlayer.sendTranslatedChatMessage(BedMessagePacket.BED_MESSAGE_KEYS[state]);
+        }
+    }
+
+    @Override
+    public void handleMapData(MapDataPacket mapdataPacket)
+    {
+        if (mapdataPacket.itemId == Items.MAP.id)
+        {
+            MapItem.getOrCreateSavedData(mapdataPacket.meta, mapdataPacket.scale, mc.theWorld).setColors(mapdataPacket.mapData);
+        }
+        else
+        {
+            System.out.println((new StringBuilder()).append("Unknown itemid: ").append(mapdataPacket.meta).toString());
+        }
+    }
+
+    @Override
+    public void handlePlaySoundEffect(PlaySoundEffectPacket playsoundeffectPacket)
+    {
+        mc.theWorld.playSoundEffect(playsoundeffectPacket.soundID, playsoundeffectPacket.x, playsoundeffectPacket.y, playsoundeffectPacket.z, playsoundeffectPacket.data);
+    }
+
+	@Override
+	public void handlePlaySoundDirectly(PlaySoundEffectDirectPacket packet) {
+		String soundPath = SoundTypes.getSoundById(packet.soundId);
+		if(soundPath == null) {
+			return;
+		}
+		mc.sndManager.playSoundAt(soundPath, packet.soundType, (float) packet.x, (float) packet.y, (float) packet.z, packet.volume, packet.pitch);
+	}
+    
+    @Override
+    public void handleSpawnParticle(AddParticlePacket addParticlePacket)
+    {
+        if (addParticlePacket.isGroup){
+            for (int i = 0; i < addParticlePacket.amount; i++) {
+                mc.renderGlobal.addParticle(addParticlePacket.particleKey,
+                        addParticlePacket.x + rand.nextDouble() * addParticlePacket.randOffX,
+                        addParticlePacket.y + rand.nextDouble() * addParticlePacket.randOffY,
+                        addParticlePacket.z + rand.nextDouble() * addParticlePacket.randOffZ,
+                        addParticlePacket.motionX + rand.nextGaussian() * addParticlePacket.randMotionX,
+                        addParticlePacket.motionY + rand.nextGaussian() * addParticlePacket.randMotionY,
+                        addParticlePacket.motionZ + rand.nextGaussian() * addParticlePacket.randMotionZ,
+                        addParticlePacket.data,
+                        addParticlePacket.maxDistance);
+            }
+        } else {
+            mc.renderGlobal.addParticle(addParticlePacket.particleKey,
+                    addParticlePacket.x,
+                    addParticlePacket.y,
+                    addParticlePacket.z,
+                    addParticlePacket.motionX,
+                    addParticlePacket.motionY,
+                    addParticlePacket.motionZ,
+                    addParticlePacket.data,
+                    addParticlePacket.maxDistance);
+        }
+
+    }
+
+    @Override
+    public void handleStatistic(StatisticPacket statisticPacket)
+    {
+        mc.thePlayer.addStat(StatList.getStat(statisticPacket.statID), statisticPacket.valueChange);
+    }
+
+    @Override
+    public void handleEntityPlayerGamemode(PlayerGamemodePacket packet)
+    {
+        Entity entity = getEntityByID(packet.entityId);
+        if (entity instanceof Player){
+            ((Player) entity).setGamemode(Gamemode.gamemodesList[packet.gamemodeId]);
+        }
+    }
+
+    @Override
+    public void handleEntityNickname(EntityNicknamePacket entityNicknamePacket)
+    {
+        Entity entity = getEntityByID(entityNicknamePacket.entityId);
+
+        if (entity instanceof Mob) {
+            ((Mob) entity).nickname = StringUtils.substring(entityNicknamePacket.nickname, 0, 32);
+            ((Mob) entity).chatColor = entityNicknamePacket.chatColor;
+        }
+    }
+
+    @Override
+    public boolean isServerHandler()
+    {
+        return false;
+    }
+    
+    @Override
+    public void handleBlockItemSwitch(SetCarriedItemPacket packet16blockitemswitch) {
+        mc.thePlayer.inventory.currentItem = packet16blockitemswitch.id;
+    }
+
+    @Override
+    public void handleTileEntityData(BlockEntityDataPacket packet)
+    {
+        Class<?> clazz = BlockEntity.getClassFromID(packet.tag.getString("id"));
+        if (clazz == null) return;
+        BlockEntity existingBlockEntity = worldClient.getBlockEntity(packet.tag.getInteger("x"), packet.tag.getInteger("y"), packet.tag.getInteger("z"));
+        if (existingBlockEntity == null || existingBlockEntity.getClass() != clazz)
+        {
+            BlockEntity blockEntity = BlockEntity.createAndLoadEntity(packet.tag);
+            if (blockEntity != null)
+            {
+                mc.theWorld.setBlockTileEntity(blockEntity.x, blockEntity.y, blockEntity.z, blockEntity);
+            }
+        }
+        else
+        {
+            existingBlockEntity.readFromNBT(packet.tag);
+        }
+        worldClient.markBlockDirty(packet.tag.getInteger("x"), packet.tag.getInteger("y"), packet.tag.getInteger("z"));
+    }
+
+    @Override
+    public void handleGameRule(GameRulePacket packet) {
+        LevelData levelData = mc.theWorld.getLevelData();
+        if (packet.getGameRules() != null) {
+            levelData.getGameRules().setValues(packet.getGameRules());
+        }
+    }
+
+    @Override
+    public void handleSyncedRecipe(RecipeSyncPacket recipeSyncPacket) {
+        if(Registries.RECIPES.getAllSerializableRecipes().isEmpty()){
+            System.out.println("Receiving "+ recipeSyncPacket.maxRecipes+" recipes from server..");
+        }
+        DataLoader.loadRecipeFromServer(recipeSyncPacket);
+        if(Registries.RECIPES.getAllSerializableRecipes().size() == recipeSyncPacket.maxRecipes){
+            System.out.println("All recipes received!");
+            Registries.RECIPES.invalidateCaches();
+            SearchPage.searchField.setText("_");
+            PageManager.searchQuery = SearchQuery.resolve(SearchPage.searchField.getText());
+            GuiGuidebook.getPageManager().updatePages();
+            SearchPage.searchField.setText("");
+            PageManager.searchQuery = SearchQuery.resolve(SearchPage.searchField.getText());
+            GuiGuidebook.getPageManager().updatePages();
+        }
+    }
+    
+    @Override
+    public void handleIds(SyncIDsPacket packet) {
+    	SoundTypes.setSoundIds(packet.soundIds);
+    }
+    
+    @Override
+    public void handleCustomPayload(CustomPayloadPacket packet) {
+    	
+    }
+}
